function clearStatsOpen()
{
    for(%a = 0; %a < ClientGroup.getCount(); %a++)
    {
        ClientGroup.getObject(%a).statsOpen = false;
    }
}

function setGlobalVideo(%a, %b)
{
    $currentGlobalVideo = %a;
    $currentGlobalVideo::workAround = %b;
    clearStatsOpen();
}

function serverCmdPlayYouTubeTo(%client, %target, %video)
{
	if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
	{
		return;
	}
	
	%target = findClientByName(%target);
	
	if (!isObject(%target))
	{
		messageClient(%client, '', "No client found");
		return;
	}
	
	if (!isObject(%target.player))
	{
		messageClient(%client, '', "Player isn't alive");
		return;
	}
	
	%video = getSubStr(%video, strLen(%video) - 11, 11);
    
    %suffix = (%time $= "") ? "?start=0&autoplay=1" : "?start=" @ %time @ "&autoplay=1";
	
	%target.chatMessage("\c5" @ %client.getPlayerName() SPC "is playing YouTube video" SPC %video SPC "@" SPC ((%time $= "") ? "0" : %time) SPC "to you.");
	commandToClient(%target, 'CEF_goToURL', "https://www.youtube.com/embed/" @ %video @ %suffix);
}

function serverCmdPlayVimeoTo(%client, %target, %video, %loop) // DOES NOT WORK
{
	if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
	{
		return;
	}
	
	%target = findClientByName(%target);
	
	if (!isObject(%target))
	{
		messageClient(%client, '', "No client found");
		return;
	}
	
	if (!isObject(%target.player))
	{
		messageClient(%client, '', "Player isn't alive");
		return;
	}
	
    if (strLen(%video) >= 9)
    {
        %video = getSubStr(%video, strLen(%video) - 9, 9);
    }

	%target.chatMessage("\c5" @ %client.getPlayerName() SPC "is playing Vimeo video" SPC %video SPC "to you.");
	commandToClient(%target, 'CEF_goToURL', "https://player.vimeo.com/video/" @ %video @ "?autoplay=1" @ (%loop == 1) ? "?loop=1" : "");
}

function serverCmdPlayYouTubeAll(%client, %video, %time, %workaround)
{
	if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
	{
		return;
	}
	
	%video = getSubStr(%video, strLen(%video) - 11, 11);
    %time = mFloatLength(%time, 0);
    
    %suffix = (%time $= "") ? "?start=0" : "?start=" @ %time;
	
	messageAll('MsgAdminForce', "\c5" @ %client.getPlayerName() SPC "is playing YouTube video" SPC %video SPC "@" SPC ((%time $= "") ? "0" : %time));
    
    if (!%workaround)
    {
        setGlobalVideo("https://www.youtube.com/embed/" @ %video @ %suffix @ "&autoplay=1&color=white&iv_load_policy=3");
    }
    else
    {
        setGlobalVideo("https://youtu.be/" @ %video @ "?t=" @ %time, "A");
        schedule(2000, 0, commandToAll, 'CEF_mouseClick', 1405, 775, 0);
    }
    
	commandToAll('CEF_goToURL', $currentGlobalVideo);
} // &modestbranding=1

function serverCmdSearchYouTubeAll(%client, %video, %time, %workaround)
{
    if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
    {
        return;
    }

    %video = strReplace(%video, "_", " ");
    %time = mFloatLength(%time, 0);

    %suffix = (%time $= "") ? "?start=0" : "?start=" @ %time;

    messageAll('MsgAdminForce', "\c5" @ %client.getPlayerName() SPC "is searching YouTube for" SPC %video SPC "@" SPC ((%time $= "") ? "0" : %time));

    if (!%workaround)
    {
        setGlobalVideo("https://www.youtube.com/embed?listType=search&list=" @ %video @ %suffix @ "&color=white&iv_load_policy=3", "");
        schedule(1500, 0, commandToAll, 'CEF_mouseClick', 768, 1024, 0);
    }
    else
    {
        setGlobalVideo("https://www.youtube.com/results?search_query=" @ strReplace(%video, " ", "+"), "B");
        schedule(1500, 0, commandToAll, 'CEF_mouseClick', 700, 200, 0);
        schedule(3000, 0, commandToAll, 'CEF_mouseClick', 1405, 775, 0);
        schedule(3000, 0, commandToAll, 'CEF_mouseClick', 1405, 1005, 0);
    }

	commandToAll('CEF_goToURL', $currentGlobalVideo);
}

function serverCmdSearchYouTubeAllB(%client, %v0, %v1, %v2, %v3, %v4, %v5, %v6, %v7, %v8, %v9, %v10)
{
    if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
    {
        return;
    }
    
    for (%i = 0; %i < 11; %i++)
    {
        %video = trim(%video SPC %v[%i]);
    }
    
    messageAll('MsgAdminForce', "\c5" @ %client.getPlayerName() SPC "is searching YouTube for" SPC %video);

    setGlobalVideo("https://www.youtube.com/embed?listType=search&list=" @ %video @ %suffix @ "&color=white&iv_load_policy=3");
    clearStatsOpen();
    schedule(1500, 0, commandToAll, 'CEF_mouseClick', 768, 1024, 0);
    
	commandToAll('CEF_goToURL', $currentGlobalVideo);
}

function serverCmdSearchYouTubeAllC(%client, %v0, %v1, %v2, %v3, %v4, %v5, %v6, %v7, %v8, %v9, %v10)
{
    if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
    {
        return;
    }
    
    for (%i = 0; %i < 11; %i++)
    {
        %video = trim(%video SPC %v[%i]);
    }
    
    messageAll('MsgAdminForce', "\c5" @ %client.getPlayerName() SPC "is searching YouTube for" SPC %video);
    
    setGlobalVideo("https://www.youtube.com/results?search_query=" @ strReplace(%video, " ", "+"), "B");
    schedule(1500, 0, commandToAll, 'CEF_mouseClick', 700, 200, 0);
    schedule(3000, 0, commandToAll, 'CEF_mouseClick', 1405, 775, 0);
    schedule(3000, 0, commandToAll, 'CEF_mouseClick', 1405, 1005, 0);
    
	commandToAll('CEF_goToURL', $currentGlobalVideo);
}
               
function serverCmdSearchDDG(%client, %a0, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
{
    if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
    {
        return;
    }
    
    for (%i = 0; %i < 11; %i++)
    {
        %search = trim(%search SPC %a[%i]);
    }
    
    messageAll('MsgAdminForce', "\c5" @ %client.getPlayerName() SPC "is searching DuckDuckGo for" SPC %search);

    setGlobalVideo("https://duckduckgo.com/?q=!ducky" SPC %search);
    commandToAll('CEF_goToURL', $currentGlobalVideo);
}

function serverCmdPlayVimeoAll(%client, %video, %loop) // DOES NOT WORK
{
	if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
	{
		return;
	}
	
    if (strLen(%video) >= 9)
    {
        %video = getSubStr(%video, strLen(%video) - 9, 9);
    }
    
    %loop = (%loop == 1) ? "?loop=1" : "";
	
	messageAll('MsgAdminForce', "\c5" @ %client.getPlayerName() SPC "is playing Vimeo video" SPC %video);
    
    setGlobalVideo("https://player.vimeo.com/video/" @ %video @ "?autoplay=1&rel=0" @ %loop);
	commandToAll('CEF_goToURL', $currentGlobalVideo);
}

function serverCmdGoToURLAll(%client, %url)
{
	if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
	{
		return;
	}

	messageAll('MsgAdminForce', "\c5" @ %client.getPlayerName() SPC "is going to URL" SPC %url);
    setGlobalVideo(%url, "C");
	commandToAll('CEF_goToURL', %url);
}

function serverCmdMouseMoveAll(%client, %a, %b)
{
	if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
	{
		return;
	}
	
	messageAll('MsgAdminForce', "\c5" @ %client.getPlayerName() SPC "is moving mouse to" SPC %a SPC %b);
	commandToAll('CEF_mouseMove', %a, %b);
}

function serverCmdMouseClickAll(%client, %a, %b, %c)
{
	if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
	{
		return;
	}
    
    if (%c != 0 && %c != 1 && %c != 2)
        return;
	
	messageAll('MsgAdminForce', "\c5" @ %client.getPlayerName() SPC "is clicking mouse (" @ %a SPC %b @ ")" SPC %c);
	commandToAll('CEF_mouseClick', %a, %b, %c);
}

function serverCmdMouseWheelAll(%client, %a, %b, %c, %d)
{
	if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
	{
		return;
	}
	
	messageAll('MsgAdminForce', "\c5" @ %client.getPlayerName() SPC "is wheeling mouse (" @ %a SPC %b @ ")" SPC %c SPC %d);
	commandToAll('CEF_mouseWheel', %a, %b, %c, %d);
}

function serverCmdPlayBlank(%client)
{
	if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
	{
		return;
	}
	
	messageAll('MsgAdminForce', "\c5" @ %client.getPlayerName() SPC "is going to URL about:blank");
    $currentGlobalVideo = "about:blank";
	commandToAll('CEF_goToURL', "about:blank");
}

function serverCmdCEF_Version(%client, %major, %minor, %revision)
{
	%client.chatMessage("You are using CEF version" SPC %major @ "." @ %minor @ "." @ %revision);
}

function serverCmdCEFVersionCheck(%client)
{
	if (!%client.isSuperAdmin && !%client.canDoCinemaCmds)
	{
		return;
	}
	
	commandToAll('CEF_Version');
}

function serverCmdYouTubeQuality(%client, %quality)
{
    //commandToClient(%client, 'CEF_goToURL', "https://www.youtube.com/embed/ayf1sYiNLhQ?autoplay=1");
    commandToClient(%client, 'CEF_goToURL', "https://www.youtube.com/embed/VHP5nEO45uQ?autoplay=1&rel=0");
    
    schedule(750, 0, commandToClient, %client, 'CEF_mouseClick', 1900, 1520, 0);
    schedule(1250, 0, commandToClient, %client, 'CEF_mouseClick', 1900, 1470, 0);
    
    switch$ (%quality)
    {
        case "4320p60" or "4320p" or "4320" or "8K" or "maximum" or "max": 
            schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1950, 1170, 0);       
        case "2160p60" or "2160p" or "2160" or "4K": 
            schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1950, 1200, 0);
        case "1440p60" or "1440p" or "1440" or "WQHD": 
            schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1950, 1235, 0);
        case "1080p60" or "1080p" or "1080" or "FHD": 
            schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1950, 1270, 0);
        case "720p60" or "720p" or "720" or "HD": 
            schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1950, 1305, 0);
        case "480p" or "480p" or "480" or "VGA" or "FWVGA": 
            schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1950, 1330, 0);
        case "360p" or "360p" or "360" or "HHD" or "NHD": 
            schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1950, 1365, 0);
        case "240p" or "240p" or "240" or "QVGA": 
            schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1950, 1400, 0);
        case "144p" or "144p" or "144" or "minimum" or "min": 
            schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1950, 1435, 0);
        case "auto" or "automatic": 
            schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1950, 1450, 0);
        default: 
            schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1950, 1450, 0);
    }

    schedule(2500, 0, commandToClient, %client, 'CEF_goToURL', $currentGlobalVideo);
    
    if (strStr($currentGlobalVideo, "autoplay") == -1 && $currentGlobalVideo::workAround $= "")
    {
        schedule(3500, 0, commandToClient, %client, 'CEF_mouseClick', 768, 1024, 0);
    }
    
    if ($currentGlobalVideo::workAround $= "A")
    {
        schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1405, 775, 0);
    }
    if ($currentGlobalVideo::workAround $= "B")
    {
        schedule(3500, 0, commandToClient, %client, 'CEF_mouseClick', 700, 200, 0);
        schedule(4500, 0, commandToClient, %client, 'CEF_mouseClick', 1405, 775, 0);
        schedule(4500, 0, commandToClient, %client, 'CEF_mouseClick', 1405, 1005, 0);
    }
}

function serverCmdYouTubeQualityCheck(%client)
{
    if ($currentGlobalVideo::workAround $= "")
    {
        commandToClient(%client, 'CEF_mouseClick', 1915, 1520, 0);
        schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1900, 1536, 0);
    }
    else if ($currentGlobalVideo::workAround $= "A")
    {
        commandToClient(%client, 'CEF_mouseClick', 1950, 1520, 0);
        schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1700, 1520, 0);
    }
    else if ($currentGlobalVideo::workAround $= "B")
    {
        commandToClient(%client, 'CEF_mouseClick', 1950, 1520, 0);
        schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1950, 1500, 0);
    }
}

function serverCmdYouTubeCaptionsToggle(%client)
{
    commandToClient(%client, 'CEF_mouseClick', 1870, 1520, 0);
    commandToClient(%client, 'CEF_mouseClick', 1800, 1520, 0);
}

function serverCmdYouTubePauseToggle(%client)
{
    commandToClient(%client, 'CEF_mouseClick', 1024, 768, 0);
}

function serverCmdYouTubeSkipAd(%client)
{
    commandToClient(%client, 'CEF_mouseClick', 1950, 1400, 0);
}

function serverCmdYoutTubeAutoplayToggle(%client)
{
    commandToClient(%client, 'CEF_mouseClick', 1830, 85, 0);
}

function serverCmdYouTubeStats(%client)
{
    switch(%client.statsOpen)
    {
        case 0:
            commandToClient(%client, 'CEF_mouseClick', 1024, 768, 2);
            if ($currentGlobalVideo::workAround !$= "")
                schedule(300, 0 , commandToClient, %client, 'CEF_mouseClick', 1120, 1080, 0);
            else
                schedule(300, 0 , commandToClient, %client, 'CEF_mouseClick', 1080, 980, 0);
            %client.statsOpen = true;
        case 1:
            if ($currentGlobalVideo::workAround !$= "")
                commandToClient(%client, 'CEF_mouseClick', 595, 32, 0);
            else
                commandToClient(%client, 'CEF_mouseClick', 495, 25, 0);
            %client.statsOpen = false;
    }
}

function serverCmdCinema(%client)
{
    %client.chatMessage("<a:https://github.com/paperworx/BlocklandCEF/wiki/Installation>https://github.com/paperworx/BlocklandCEF/wiki/Installation</a>");
}

function serverCmdCurrentGlobalVideo(%client)
{
    %client.chatMessage("<a:" @ $currentGlobalVideo @ ">" @ $currentGlobalVideo @ "</a>");
}

function serverCmdReload(%client)
{
    commandToClient(%client, 'CEF_goToURL', $currentGlobalVideo);
            
    if (strStr($currentGlobalVideo, "autoplay") == -1 && $currentGlobalVideo::workAround $= "")
    {
        schedule(1000, 0, commandToClient, %client, 'CEF_mouseClick', 768, 1024, 0);
    }

    if ($currentGlobalVideo::workAround $= "A")
    {
        schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1405, 775, 0);
    }
    if ($currentGlobalVideo::workAround $= "B")
    {
        schedule(1500, 0, commandToClient, %client, 'CEF_mouseClick', 700, 200, 0);
        schedule(2500, 0, commandToClient, %client, 'CEF_mouseClick', 1405, 775, 0);
        schedule(2500, 0, commandToClient, %client, 'CEF_mouseClick', 1405, 1005, 0);
        schedule(2500, 0, commandToClient, %client, 'CEF_mouseClick', 1405, 1350, 0);
    }
}

function serverCmdCinemaChecklist(%client)
{
    %client.chatMessage("\c61. Blockland CEF downloaded (/cinema)");
    %client.chatMessage("\c62. Blockland closed");
    %client.chatMessage("\c63. Extracted zip to Blockland folder, allowing overwrites");
    %client.chatMessage("\c64. Blockland.exe set to read-only");
    %client.chatMessage("\c65. Download Textures Enabled");
    %client.chatMessage("\c66. Texture Quality set to High or above");
    %client.chatMessage("\c67. CEF_BindTexture();");
}

function serverCmdCinemaHelp(%client)
{
    %client.chatMessage("\c6/Cinema - to download CEF");
    %client.chatMessage("\c6/CinemaChecklist - to ensure CEF works");
    %client.chatMessage("\c6/YouTubeQuality (maximum, 2160p, 1440, 720p60, min, auto, etc) - set video quality");
    %client.chatMessage("\c6/YouTubeQualityCheck - check current quality settings");
    %client.chatMessage("\c6/YouTubeCaptionsToggle - toggle captions if available");
    %client.chatMessage("\c6/YouTubePauseToggle - pauses the video");
    %client.chatMessage("\c6/YouTubeSkipAd - skips skippable ads");
    %client.chatMessage("\c6/YouTubeAutoplayToggle - toggle autoplay on youtube pages");
    %client.chatMessage("\c6/YouTubeStats - nerd stats");
    %client.chatMessage("\c6/CurrentGlobalVideo - view the current global video");
    %client.chatMessage("\c6/Reload - reloads current URL");
    
    if (%client.isSuperAdmin || %client.canDoCinemaCmds)
    {
        %client.chatMessage("\c5/PlayYouTubeTo (client) (videoID) - play YT video to a person");
        %client.chatMessage("\c5/PlayYouTubeAll (videoID) (time in s) (workaround) - play YT video to everyone");
        %client.chatMessage("\c5/SearchYouTubeAll (search_Terms) (time in s) (workaround) - searches for a YT video - underscores needed for first argument");
        %client.chatMessage("\c5/PlayYouTubeAllB (search terms) - play YT video to a person - no underscores needed");
        %client.chatMessage("\c5/PlayYouTubeAllC (search terms) - same as above with workaround enabled");
        %client.chatMessage("\c5/SearchDDG (search terms) - searches DuckDuckGo for a website");
        %client.chatMessage("\c5/GoToUrlAll (url) - sends everyone to specified URL");
        %client.chatMessage("\c5/MouseClickAll (posX) (posY) (type) - clicks mouse for everyone");
        %client.chatMessage("\c5/PlayBlank - goes to about:blank");
        %client.chatMessage("\c5/CEFVersionCheck - tells everyone their CEF version");
    }
}

function serverCmdCinemaControlAccess(%client, %action, %target)
{
    if (!%client.isSuperAdmin)
    {
        return;
    }
    
    if (%action !$= "grant" && %action !$= "deny")
    {
        %client.chatMessage("Invalid action");
        return;
    }
    
    %target = findClientByName(%target);
    
    if (!isObject(%target))
    {
        %client.chatMessage("No client found");
        return;
    }
    
    if (%target.isSuperAdmin || (%target.canDoCinemaCmds && %action $= "grant"))
    {
        %client.chatMessage("Player can already use cinema commands");
        return;
    }
    
    if (!%target.canDoCinemaCmds && %action $= "deny")
    {
        %client.chatMessage("Player can not use cinema commands already");
        return;
    }
    
    switch$(%action)
    {
        case "grant":
            %target.canDoCinemaCmds = true;
            announce(%target.getPlayerName() SPC "can now use Cinema commands.");
        case "deny":
            %target.canDoCinemaCmds = false;
            announce(%target.getPlayerName() SPC "can no longer use Cinema commands.");
    }
}

package PlayVideoOnJoin
{
    function gameConnection::SpawnPlayer(%client)
    {
        Parent::SpawnPlayer(%client);
        
        if ($firstSpawn[%client.getBLID()] $= "")
        {
            commandToClient(%client, 'CEF_setResolution', 1536, 2048);
            
            if ($currentGlobalVideo !$= "")
            {
                commandToClient(%client, 'CEF_goToURL', $currentGlobalVideo);

                if (strStr($currentGlobalVideo, "autoplay") == -1 && $currentGlobalVideo::workAround $= "")
                {
                    schedule(1000, 0, commandToClient, %client, 'CEF_mouseClick', 768, 1024, 0);
                }
            
                if ($currentGlobalVideo::workAround $= "A")
                {
                    schedule(2000, 0, commandToClient, %client, 'CEF_mouseClick', 1405, 775, 0);
                }
                if ($currentGlobalVideo::workAround $= "B")
                {
                    schedule(1500, 0, commandToClient, %client, 'CEF_mouseClick', 700, 200, 0);
                    schedule(2500, 0, commandToClient, %client, 'CEF_mouseClick', 1405, 775, 0);
                    schedule(2500, 0, commandToClient, %client, 'CEF_mouseClick', 1405, 1005, 0);
                    schedule(2500, 0, commandToClient, %client, 'CEF_mouseClick', 1405, 1350, 0);
                }
            }
            
            $firstSpawn[%client.getBLID()] = true;
        }
    }
    
    function gameConnection::onClientLeaveGame(%client)
    {   
        Parent::onClientLeaveGame(%client);
        
        if ($firstSpawn[%client.getBLID()] == "1")
        {
            $firstSpawn[%client.getBLID()] = "";
        }
    }
};

activatePackage(PlayVideoOnJoin);

function fxDTSBrick::getBrowserPos(%this, %location) {
	%vec = vectorSub(%location, %this.getTransform());
	return ((getWord(%vec, (%this.angleID & 1) ? 0 : 1) * ((%this.angleID >> 1) ? "-1" : 1)) +  4) / 8 * 2048 SPC 1536 - (getWord(%vec, 2) + 3) / 6 * 1536;
}
package browserSupport // ONLY WORKS RIGHT WITH THE 8X6 FLAT CINEMA SCREENS
{
	function GameConnection::browserSupport(%this) {
		cancel(%this.bs);
		if(isObject(%player=%this.player)) {
			%ray = containerRaycast(%player.getEyePoint(), vectorAdd(vectorScale(%player.getEyeVector(), 300), %player.getEyePoint()), $TypeMasks::FxBrickObjectType, "");
			if(isObject(%ray) && %ray.getDatablock().printAspectRatio $= "Screen") {
				%playero = %ray.getBrowserPos(posFromRaycast(%ray));
                %this.bottomPrint("\c6" @ %playero, 3);
				commandToClient(%this, 'CEF_mouseClick', getWord(%playero, 0) | 0, getWord(%playero, 1) | 0, 4);
			}
		}
		%this.bs = %this.schedule(100, browserSupport);
	}
	function Player::activateStuff(%player) { 
		if(isObject(%client = %player.client)) {
			%ray = containerRaycast(%player.getEyePoint(), vectorAdd(vectorScale(%player.getEyeVector(), 300), %player.getEyePoint()), $TypeMasks::FxBrickObjectType, "");
			if(isObject(%ray) && %ray.getDatablock().printAspectRatio $= "Screen") {
				%playero = %ray.getBrowserPos(posFromRaycast(%ray));
				commandToClient(%client, 'CEF_mouseClick', getWord(%playero, 0) | 0, getWord(%playero, 1) | 0, 0);

			}
		}
		return Parent::activateStuff(%player);
	}
};

//activatePackage("browserSupport");